/*
* $Log$
* Revision 2.4  2006/07/30 11:44:14  rich
* MoveSprite taken from gbalib now
*
* Revision 2.3  2004/02/22 15:28:16  richq
* Added background init routine.
*
* Revision 2.2  2004/02/18 19:19:17  richq
* Mostly the same as LoM. New things are:
*  extra palette swapping and tunnel stuff.
*  scrolling view has to take into account that the mist and army gfx
*   are "hacked in" - they overlap the calculated view when very close.
*
* Revision 2.1.1.1  2004/02/04 21:49:20  Default
* Doomdark's Revenge GBA
*
*
*/
#ifndef GFX_H
#define GFX_H

#include "backgrounds.h"
#include "gba.h"
#include "sprite.h"

#define PAN_RIGHT 1
#define PAN_LEFT 2
#define FONT_TILE 6
#define BACKGROUND_INK (1)
#define BACKGROUND_PAPER (15)

// nofont set in 0
#define FONT_BLUE_B     1
#define FONT_RED_B      2
#define FONT_PURPLE_B   3
#define FONT_GREEN_B    4
#define FONT_CYAN_B     5
#define FONT_YELLOW_B   6
#define FONT_WHITE_B    7
#define FONT_BLACK      8
#define FONT_BLUE       9 
#define FONT_RED        10
#define FONT_PURPLE     11
#define FONT_GREEN      12
#define FONT_CYAN       13
#define FONT_YELLOW     14
#define FONT_WHITE      15
                        


extern Bg bg_level;
extern Bg bg_text;
extern Bg bg_horizon;

extern const u16 brightPal[];
extern const u16 nonBrightPal[];

// this pointer should be set to the speccy gfx 
// before calling createTile.
extern const u8 * gfxTable;
extern int g_panningOn;
extern int g_panning;
extern u8 * g_buffer;

// print a character at row, col
void print_text(char text, int row, int col, int pal);

void initBackground(Bg * bg, int number,
                    int charBlock, int screenBlock, 
                    int priority);
void init_backgrounds(void);
void init_gfxbuffer(void);

void load_font(void);
void clear_vram(void);
void setup_view(void);
//void drawLine (int y, int x1, int x2, int ink);
//void drawSet (int y, int x, int ink);
void clear_view(void);
void clear_text(void);
void clear_text_from(int startY);

void move_sprite(int id, int x, int y);
void CopyOAM(void);

void createTile(u8 * pixels, int tile, int pen, int paper);
void drawImage(const u8 * pixels, u8 col, u8 row, u8 sprite);

void remove_sprite(int id);
void init_sprite64(int id, int priority);
void clearSpriteRAM(u8 sprite);

void set_horizon(void);
void fade_up(void);

void set_palette_time(int time);
void set_think_palette(void);
void set_night_palette(void);
void set_tunnel_palette(void);
void set_flame_tile(int x, int y);

void drawLineToBuffer(int x1, int x2, int yOffset, int colour);
void drawSetToBuffer(int x, int yOffset, int colour);
void clearBuffer(void);

void scrollBufferLeft(void);
void scrollBufferRight(void); 

void fade_up(void);
void fade_down(void);


#endif

