/*
* $Log$
* Revision 2.2  2004/02/18 19:18:54  richq
* Handles low-ish level player input. Similar in design to LoM.
*
* Revision 2.1.1.1  2004/02/04 21:49:20  Default
* Doomdark's Revenge GBA
*
*
*/

#include "gba.h"
#include "keypad.h"
#include "screenmode.h"

#include "select.h"
#include "choose.h"
#include "look.h"
#include "menu.h"
#include "gfx.h"
#include "savearea.h"
#include "input.h"
#include "infoscreen.h"
#include "characters.h"
#include "night.h"
#include "main.h"

void up_pressed(void);
void down_pressed(void);
void left_pressed(void);
void right_pressed(void);
void a_pressed(void);
void b_pressed(void);
void l_pressed(void);
void r_pressed(void);
void start_pressed(void);
void select_pressed(void);


void handle_keys (void) {
  UpdateKeys();
  u16 delay = 10;
  
  
  if (KeyPressedNoBounce(KEY_UP,delay)) {
    up_pressed();
  }
  
  if (KeyPressedNoBounce(KEY_DOWN,delay)) {
    down_pressed();
    
  }
  
  
  if (KeyPressedNoBounce(KEY_LEFT,delay)) {
    left_pressed();
  }
  
  if (KeyPressedNoBounce(KEY_RIGHT,delay)) {
    right_pressed();
    
  }
  
  
  if (KeyPressedNoBounce(KEY_START,120)) {
    start_pressed();
  }
  
  if (KeyPressedNoBounce(KEY_SELECT,200)) {
    select_pressed();
  }
  
  if (KeyPressedNoBounce(KEY_R,120)) {
    r_pressed();
  }
  
  if (KeyPressedNoBounce(KEY_L,120)) {
    l_pressed();
  }
  
  if (KeyPressedNoBounce(KEY_A,delay)) {
    a_pressed();
    
  }
  
  if (KeyPressedNoBounce(KEY_B,delay)) {
    b_pressed();
  }
  
  
}


void up_pressed(void){
  switch(g_status.screen) {
    
    case LOOK_SCREEN : 
    case PLACE_SCREEN :
    moveForwards();
    break;
    
    case CHOOSE_SCREEN :
    chooseUp();
    WaitKeyReleased(KEY_UP);
    break;
    case SELECT_SCREEN : 
    selectUp();
    WaitKeyReleased(KEY_UP);
    break;
    
    default: break;
  }

}

void down_pressed(void){

  switch(g_status.screen) {
    
    case LOOK_SCREEN : 
    infoPlace(1);
    break;
    
    case CHOOSE_SCREEN :
    chooseDown();
    WaitKeyReleased(KEY_DOWN);
    break;
    case SELECT_SCREEN : 
    selectDown();
    WaitKeyReleased(KEY_DOWN);
    break;
    
    default: break;
  }

}
 
void left_pressed(void){
  
  switch(g_status.screen) {
    case LOOK_SCREEN : 
    rotateLeft();
    break;
    
    
    case CHOOSE_SCREEN : 
      clearHighlighter();
    case DEAD_SCREEN : 
      select();
      break;
      
    case PLACE_SCREEN : 
      choose();
      break;
    case LOCATION_SCREEN :
      infoPlace(1);
      break;
    case BATTLE_STATS_SCREEN :
      infoLocation();
      break;
    case CHARACTER_SCREEN :
      battleStats();
      break;
    case SELECT_SCREEN :
      clearHighlighter();
      infoCharacter();
      break;
    
    default: break;
  }
}
void right_pressed(void){
  
  switch(g_status.screen) {
    case LOOK_SCREEN : 
    rotateRight();
    break;
    
    case CHOOSE_SCREEN : 
      clearHighlighter();
      infoPlace(1);
      break;
    case PLACE_SCREEN : 
      infoLocation();
      break;
    case LOCATION_SCREEN :
      battleStats();
      break;
    case BATTLE_STATS_SCREEN :
      infoCharacter();
      break;
    
    case DEAD_SCREEN : 
    case CHARACTER_SCREEN :
      select();
      break;
    case SELECT_SCREEN :
      clearHighlighter();
      choose();
      break;
    
    default: break;
  }

}

void a_pressed(void){
  switch(g_status.screen) {
    case LOOK_SCREEN : 
      choose();
    break;
    
    case CHOOSE_SCREEN : 
    makeChoice();
    break;
    case SELECT_SCREEN : 
    makeSelection();
    break;
    case PLACE_SCREEN :
    case LOCATION_SCREEN :
    showMoreInfo();
    break;
    
    default: break;
  }
  WaitKeyReleased(KEY_A);
  
}

void b_pressed(void){
  switch(g_status.screen) {
    case DEAD_SCREEN : 
    case LOOK_SCREEN : 
    clearHighlighter();
    select();
    break;
    
    case CHOOSE_SCREEN : 
    case PLACE_SCREEN : 
    case LOCATION_SCREEN :
    case BATTLE_STATS_SCREEN :
    case CHARACTER_SCREEN :
    case SELECT_SCREEN : 
    case MENU_SCREEN :
    clearHighlighter();
    look();
    break;
    
    default: break;
  }
  WaitKeyReleased(KEY_B);
}

void l_pressed(void){
  switch(g_status.screen) {
    
    case LOOK_SCREEN : 
    case CHOOSE_SCREEN : 
    case PLACE_SCREEN : 
    case LOCATION_SCREEN :
    case BATTLE_STATS_SCREEN :
    case CHARACTER_SCREEN :
    selectPrevChar();
    break;
    
    case SELECT_SCREEN : 
    showPrevSelectPage();
    break;
    
    default: break;
  }
  WaitKeyReleased(KEY_L);
}

void r_pressed(void){
  switch(g_status.screen) {
    case LOOK_SCREEN : 
    case CHOOSE_SCREEN : 
    case PLACE_SCREEN : 
    case LOCATION_SCREEN :
    case BATTLE_STATS_SCREEN :
    case CHARACTER_SCREEN :
    selectNextChar();
    break;
    
    case SELECT_SCREEN : 
    showNextSelectPage();
    break;
    
    default: break;
  }
  WaitKeyReleased(KEY_R);
}

void select_pressed(void){
  // where ever we are, go to the night
  clearHighlighter();
  bringTheNight();
  // game over?

  // now wait for A to be pressed, then wait for let go...
  while(1) {
    wait_vsync_int();
    UpdateKeys();
    if (KeyPressedNoBounce(KEY_A,1)) {
      break;
    }
  }
  if (!g_gameover)
    look();
  WaitKeyReleased(KEY_A);
  
}


void start_pressed(void){
  showSaveMenu();
}

