/*
* $Log$
* Revision 2.2  2004/02/22 15:07:26  richq
* 50/50 chance enemy don't move if they are at a non freindly location fix
* End game screen print out fix. Set screen to != LOOK so the fade in
* thing works properly.
*
* Revision 2.1  2004/02/18 19:15:15  richq
* Creates the night-time screen. Moves non-Moonprince characters. Moves the mists,
* places objects semi-randomly on the map, checks the gameover conditions and, if
* needed, draws the good end game screen.
*
*/

#include "night.h"
#include "savearea.h"
#include "tokendata.h"
#include "tokens.h"
#include "army.h"
#include "gfx.h"
#include "objects.h"
#include "characters.h"
#include "main.h"
#include "look.h"
#include "menu.h"
#include "location.h"
#include "flames.h"
#include "fight.h"
#include "infoscreen.h"

const location_t frozenGates = {5,0x5b};

void setupNightScreen(void) {
  // clear top screen
  clear_text();
  // clear bottom
  clear_objects();
  clearHighlighter();
  // clear shield...
  remove_shield();
  clear_view();
  CopyOAM();
  set_night_palette();
  clearBuffer();
  set_print_vars(0, 0, 0, 0x1e);
}

void createDaysCount(void) {
  if (g_saveArea.days >= 0x400) {
    addToTokenList(countlessDays);
  } else {
    g_saveArea.days++;
    numberToWords(g_saveArea.days);
    addPluralisedToken(0x6a);
    
  }
  
  
}

void doFight(int who) {
  // check if we have already calculated this character,,,
  if (IN_BATTLE(g_characters[who].flags))
    return;
  
  g_status.charInTunnel = IN_TUNNEL(g_characters[who].flags);
  g_status.loyalty = LOYALTY(g_characters[who].flags);
  
  getCharactersAt(&g_characters[who].location);
  g_localDetails.garrison_here = g_garrisonHere;
  
  if (g_unloyals_here == 0)
    return;
  
  if (g_total_here == 0)
    return;
  
  // 8198
  if (g_total_here > 1) {
    int i, fighter;
    for (i = 0; i < g_total_here; i++) {
      fighter = g_charactersHere[i];
      // set bit 4
      g_characters[fighter].flags |= IN_BATTLE_FLAG;
      // battle 7f4e
      battleVsCharacter(fighter);
    }
    
  }
  if (g_localDetails.garrison_here == 0)
    return;
  
  g_status.loyalty = getArmyLoyalty(g_localDetails.garrison_here);
  doBattle(g_localDetails.garrison_here, 0);
}


void fights(void) {
  int i;
  for (i = 0; i < 128; i++) {
    doFight(i);
  }
  
}

void aiRecruitMen(int who) {
  g_status.loyalty = LOYALTY(g_characters[who].flags);
  if (g_status.loyalty == 0)
    return;
  
  calculateGarrisonAt(&g_characters[who].location);
  if ( g_garrisonHere == 0)
    return;
  if (getArmyLoyalty(g_garrisonHere) != g_status.loyalty)
    return;
  if (getArmyRace(g_garrisonHere) != (g_characters[who].race_orders&0xf))
    return;
  int garSize = getArmySize(g_garrisonHere);
  int ourSize = getArmySize(who);
  if (garSize < ourSize+4)
    return;
  int increment = garSize - ourSize - 4;
  increaseU8By(&g_charArmies[who].size, increment);
  decreaseU8By(&g_garrisons[g_garrisonHere-128].size, increment);
  
}


//6661
/*
Remove stray creatures that have found their way to our location
Check if cpu can recruit men from a garrison
Increase happiness if we killed the foe
Reinforce fortresses/cities with new recruits
*/
void tidyNightAction(void) {
  int i;
  for (i = 0; i < 128; i++) {
    if (g_characters[i].reckless != 0) {
      // remove creature from our location
      g_map[g_characters[i].location.x + g_characters[i].location.y*64] &= ~HAS_OBJECT_FLAG;
      
      // do stuff with ai? 674e - works out garrison based losses
      // ai ii
      aiRecruitMen(i);
      
      if (KILLED_FOE(g_characters[i].flags)) {
        increaseU8By(&g_characters[i].despondence, 32);
      }
      g_locdat.x = g_fortresses[i].x;
      g_locdat.y = g_fortresses[i].y;
      fillLocationData(&g_locdat);
      if (g_locdat.terrain == FORTRESS)
        increaseU8By(&g_garrisons[i].size , 10);
      else
        increaseU8By(&g_garrisons[i].size , 20);
    }
  }
  
      
}

// returns true when we get a location
int headTowards(u8 * ourMan, location_t *target) {
  
  if (*ourMan == 0xff) {
    *target = g_characters[LUXOR].location;
    return 1;
  } else {
    if (g_characters[*ourMan].reckless) {
      *target = g_characters[*ourMan].location;
      return 1;
    }
    else {
      *ourMan = g_characters[*ourMan].liege;
      return 0;
    }
  }
  
}


// get the location we need to go to based on orders:
void getLocationFromOrders(location_t * target, int who) {
  // 829e
  // first calculate our new orders:
  int newOrders = 4;
  if (g_characters[who].liege != 0xff) {
    // has a liege. get their orders and possibly do the same thing
    newOrders = GET_ORDERS ( g_characters[g_characters[who].liege].race_orders );
  }
  
  if (newOrders > 1) {
    newOrders = randomish()&0xf;
    if (newOrders == 4) {
      // stay here...
      *target = g_characters[who].location;
      return;
    } else if (newOrders > 4) {
      newOrders = GET_ORDERS (g_characters[who].race_orders);
    }
  } else {
    newOrders = 0;
  }
  
  // save new orders
  g_characters[who].race_orders = (g_characters[who].race_orders&0xf) | (newOrders<<4);
  
  if (newOrders == 0) {
    // head towards liege
    for ( ;;) {
      if (headTowards(&g_characters[who].liege, target) )
        break;
    }
  } 
  if (newOrders == 1) {
    // head towards foe
    for ( ;;) {
      if (headTowards(&g_characters[who].foe, target) )
        break;
    }
  }  
  if (newOrders == 2) {
    // head towards object
    if (g_objects[who].x == 0xff) {
      // someone has it
      newOrders = 3;
    } else {
      *target = g_objects[who];
    }
  }  
  if (newOrders == 3) {
    // head towards our fortress
    if (who == SHARETH) {
      *target = g_fortresses[0x2b];
    }
    else {
      *target = g_fortresses[who];
    }
  }
  
}


// 65e0
void pickupObject(int who) {
  if (g_characters[who].object != 0xff) 
    return;
  s8 take;
  u8 enter;
  getEntranceAndObject(&g_characters[who].location, 
      &take,
      &enter);
  
  if (take == -1)
    return;
  g_characters[who].object = take;
  g_objects[take].y = who;
  g_objects[take].x = 0xff;
   
}

const u8 dirToGo[] = {0,2,1,4,0,3,0,6,7,0,0,5};

// move a cpu char 81e2
void moveCharacter(int who) {
  if (IN_TUNNEL (g_characters[who].flags) || 
      (LOYALTY (g_characters[who].flags) == 0) || 
      g_characters[who].reckless == 0 )
    return;
  
  //setSelectedChar(who);
  int wantToMove;
  int reachedTargetOrEnemy = 0;
  location_t target;
  getLocationFromOrders(&target, who);
  
  // loop until we run out of time, energy, reach our target or get in a fight
  do {
    pickupObject(who);
    // move towards target
    int dirFlag = 0;
    if (g_characters[who].location.x > target.x)
      dirFlag |= 1; //0
    else if (g_characters[who].location.x < target.x)
      dirFlag |= 1<<2;
    
    if (g_characters[who].location.y > target.y)
      dirFlag |= 1<<1;
    else if (g_characters[who].location.y < target.y)
      dirFlag |= 1<<3;  
    wantToMove = 0;
    if (dirFlag != 0) {
      g_characters[who].time_looking = MASK_LOOKING(g_characters[who].time_looking) | dirToGo[dirFlag - 1];
      // checkVision(who);
      workOutLocationDetails(who);
      if (g_localDetails.can_move == 0) {
        // cannot move, could be for 2 reasons: unloyals here, or blocked by stuff
        if ( TIME_LEFT(g_characters[who].time_looking) == DAWN && g_status.canDrawInfront) {
          // dawn and we are in the same place as unloyals- 50/50 chance of moving on
          if (randomish()&1) {
            wantToMove = 1;
          } 
        }
      } else { // can move != 0
        // we can move freely which is what we want to do
        wantToMove = 1;
      }
      
    } 
    if (wantToMove) {
      // 8257
      moveCharForwards(who); 
    } else {
      // don't want to move
      // possibly dirflag == 0, which means we have reached our target square
      // or else we are stood on an enemy 
      reachedTargetOrEnemy = 1;
    }
    
  } while ( (g_characters[who].energy >= 0x60) &&
            (TIME_LEFT(g_characters[who].time_looking) > 0) &&
            (reachedTargetOrEnemy == 0) );
  
  // 8268 - see if we can recruit someone
  if (g_localDetails.unloyals_here != 1) {
    return;
  }
  
  getCharactersAt(&g_characters[who].location);
  
  if (g_total_here != 2) 
    return;
  int them = g_charactersHere[0];
  if (them == who)
    them = g_charactersHere[1];
  
  doApproach(them, who);
  
}


/*
Refresh the characters (i.e. set time to dawn, increment energy)
Move CPU chars towards their target square
Reset battle flags
*/
void refreshAndMove(void) {
  //660f 
  int i;
  for (i = 0; i < 128; i++) {
    if (g_characters[i].reckless != 0) {
      
      /* Good night's sleep */
      g_characters[i].time_looking = (g_characters[i].time_looking&7)| (DAWN<<3);
      // increase energy a bit (more if loyal to moony)
      if (LOYALTY(g_characters[i].flags) == 0)
        increaseU8By(&g_characters[i].energy, 20);
      else
        increaseU8By(&g_characters[i].energy, 10);
      
      /* Army/battle stats updates */
      //g_characters[i].flags &= 0xC7;    // 11000111 - clear battle stats flags
      g_characters[i].flags &= ~(KILLED_FOE_FLAG|IN_BATTLE_FLAG|WON_BATTLE_FLAG);
      g_charArmies[i].slew = 0;
      g_charArmies[i].lost = 0;
      g_characters[i].fighting = 0xff;
      
      // AI part i to follow - set target location based on orders
      // 81e2
      moveCharacter(i);
      
    }
  }
  
}

// 
void describeEndGame(int vicToken, int victoryConditions) {
  
  g_saveArea.selectedChar = LUXOR;
  drawFeatureAndChar();
  addToTokenList(after_);
  createDaysCount();
  addToTokenList(theWarriorsReturn);
  int i;
  for (i = 0; i < SHARETH; i++) {
    if (g_characters[i].reckless != 0 &&          /*alive*/
        g_characters[i].location.x == frozenGates.x &&  /*at gate.x*/
        g_characters[i].location.y == frozenGates.y     /*at gate.y*/
        ) 
    {
      createCharacterName(i);
      addToTokenList(isHere_);
      print_tokens_pal(FONT_RED);
    }
  }
  if (g_characters[SHARETH].reckless == 0) {
    createCharacterName(SHARETH);
    addToTokenList(isDead_);
  }
  addToTokenList(theVictIs);
  
  if (vicToken != 0xcd) { 
    // not overwhelming
    // utterly noble, etc
    addSingleToken(0x45+ victoryConditions);
    addSingleToken(vicToken);
    addLiteralToken('.');
  } else {
    // 
    addSingleToken(vicToken);
    addToTokenList(theWatchWords);
  }
  print_tokens_pal(FONT_RED);
  
}


// check the end conditions
int checkGameOver(void) {
  // 886b
  int i;
  u8 victoryConditions = 6;
  int madeItHome = 0;
  int vicToken = 0xcb; //worthy
  // loop on the 4 heroes
  for (i = 0; i < SHARETH; i++) {
    if (g_characters[i].reckless != 0 &&          /*alive*/
        (LOYALTY(g_characters[i].flags)==0) &&    /*ally*/
        g_characters[i].location.x == frozenGates.x &&  /*at gate.x*/
        g_characters[i].location.y == frozenGates.y     /*at gate.y*/
        ) 
    {
      victoryConditions--;
      madeItHome++;
      if (g_characters[i].object < 5) {
        victoryConditions--;
      }
    }
    madeItHome<<=1;
  }
  
  if (g_characters[SHARETH].reckless == 0) {
    victoryConditions--;
    madeItHome++;
    vicToken = 0xcc;  //noble
  }
  // makes use of overflow of u8s
  if (victoryConditions >= 5) {
    victoryConditions = 0;
  }
  if (madeItHome == 31) {
    vicToken = 0xcd;  //overwhelming
    describeEndGame(vicToken, victoryConditions);
  } else {
    if ( (madeItHome & (1<<4)) == 0) // luxor not home
      return 0;
    if ( ((madeItHome & (1<<3)) == 0) && (madeItHome & 1) == 0) {
      // morkin not home, shareth still alive
      return 0;
    }
    // else, morkin is home or shareth is dead
    describeEndGame(vicToken, victoryConditions);
  }
  return 1;
}

// 6600
void bringTheNight(void) {
  g_status.screen = BATTLE_STATS_SCREEN;
  if (checkGameOver()) {
    g_gameover = 1;
    return;
  }
  
  setupNightScreen();
  
  addToTokenList(itIs);
  createDaysCount();
  addToTokenList(sinceRodeForth);
  
  print_tokens_pal(FONT_GREEN_B);
  
  clearArmyTiles();
  
  refreshAndMove();
  fights();
  moveMists();
  putThingsOnMap();
  
  tidyNightAction();
  
  
  setArmyTiles();
  
  checkDeadChar(MORKIN);
  checkDeadChar(SHARETH);
  
  addToTokenList(dawnBreaks);
  
  print_tokens_pal(FONT_GREEN_B);
  
}

