/*
* $Log$
* Revision 2.3  2004/02/22 15:01:46  richq
* Token lists for map screen
*
* Revision 2.2  2004/02/18 19:11:51  richq
* Same as LoM, but different. ;)
*
* Revision 2.1.1.1  2004/02/04 21:49:21  Default
* Doomdark's Revenge GBA
*
*                                                                              
*/

#ifndef _TOKENDATA_H
#define _TOKENDATA_H

#include "gba.h"


/*

See below for code!

For the record, the text tokens in Doomdark are as follows:
00 plains
01 mountains
02 forest
03 hills
04 gate
05 temple
06 pit
07 palace
08 fortress
09 hall
0a hut
0b tower
0c city
0d fountain
0e stones
0f frozen
10 wastes
11 the
12 of
13 luxor
14 morkin
15 tarithel
16 rorthron
17 shareth
18 north
19 northeast
1a east
1b southeast
1c south
1d southwest
1e west
1f northwest
20 moonprince
21 free
22 wise
23 fey
24 barbarian
25 giant
26 dwarf
27 icelord
28 heartstealer
29 on
2a in
2b at
2c to
2d stands
2e looking
2f into
30 mist
31 tunnel
32 a
33 more
34 is
35 good
36 strong
37 forceful
38 generous
39 stubborn
3a brave
3b swift
3c loyal
3d evil
3e weak
3f reticent
40 greedy
41 fawning
42 cowardly
43 slow
44 treacherous
45 utterly
46 extremely
47 very
48 quite
49 somewhat
4a slightly
4b not
4c not at all
4d despondent
4e tired
4f reckless
50 and
51 liege
52 foe
53 hundred
54 score
55 no
56 one
57 two
58 three
59 four
5a five
5b six
5c seven
5d eight
5e nine
5f ten
60 eleven
61 twelve
62 thirteen
63 fourteen
64 fifteen
65 sixteen
66 seventeen
67 eighteen
68 nineteen
69 hour
6a day
6b remain
6c it
6d whose
6e power
6f commands
70 riders
71 warriors
72 none
73 they
74 are
75 holds
76 moonguard
77 iceguard
78 here
79 ahead
7a army
7b dragons
7c wolves
7d trolls
7e skulkrin
7f horses
80 guidance
81 shelter
82 claws
83 flames
84 thorns
85 blood
86 languor
87 springs
88 night
89 dawn
8a despair
8b courage
8c death
8d life
8e crown
8f runes
90 spell
91 spear
92 axe
93 hammer
94 sword
95 bow
96 persuasion
97 protection
98 swiftness
99 battle
9a carries
9b nothing
9c has
9d found
9e slain
9f them
a0 can
a1 be
a2 hands
a3 prepares
a4 do
a5 fought
a6 won
a7 lost
a8 victory
a9 slew
aa alone
ab sees
ac an
ad underground
ae entrance
af rest
b0 take
b1 give
b2 enter
b3 recruit
b4 post
b5 attack
b6 approach
b7 use
b8 who
b9 owned
ba by
bb since
bc rode
bd forth
be icemark
bf breaks
c0 dead
c1 watchwords
c2 midnight
c3 are
c4 revealed
c5 fear
c6 mighty
c7 hosts
c8 unto
c9 we
ca go
cb worthy
cc noble
cd overwhelming
ce loading
cf saving
d0 verifying
d1 failed
d2 do you want to try again ?
d3 start tape and press enter.
d4 after
d5 return
d6 or
d7 countless
d8 against
d9 save
da load
db delete
dc game
dd scrolling view
de x

*/



#define tokendict _binary_tokendict_bin_start
extern u8 tokendict[];

// define indices for start of each dictionary...
#define NAME_DICT_1   (0)
#define NAME_DICT_2   (66)
#define NAME_DICT_3   (43+NAME_DICT_2)
#define namedicts _binary_namedicts_bin_start
extern u8 namedicts[];

#define PLACENAME 0xfa
#define NEWLINE   0xfb
#define UPPERCASE 0xfc
#define NOSPACE   0xfd
#define LITERAL   0xfe
#define ENDTOKEN  0xff


// updated for DDR:
extern const u8 the_[];
extern const u8 of_[];
extern const u8 raceNames [];
extern const u8 phrasalEndings[];
extern const u8 intoTheMist[];
extern const u8 nightTime[];
extern const u8 dawnTime[];
extern const u8 ofTheDay[];

extern const u8 itIsDawn[];
extern const u8 itIsNight[];
extern const u8 ofTheDay[];

extern const u8 canDoNothing[];
extern const u8 objectUses[];
extern const u8 objectTypes[];

extern const u8 whosePowerIsIn[];
extern const u8 theTunnel[];
extern const u8 anUndergroundTunnel[];

extern const u8 theFoe[];

extern const u8 anUndergroundEntrance[];

extern const u8 Here_[];
extern const u8 hasFound[];

extern const u8 andSlainThem[];

extern const u8 dash_[];
extern const u8 canBeFound[];
extern const u8 inTheHandsOf[];

extern const u8 preparesToBattle[] ;

extern const u8 itIs[];
extern const u8 countlessDays[];
extern const u8 sinceRodeForth[];
extern const u8 dawnBreaks[];
extern const u8 isDeadSlainBy[];
extern const u8 foughtNothing[];
extern const u8 inBattle[];
extern const u8 victory_[];
extern const u8 apostropheS[];
extern const u8 ofTheFoe[];
extern const u8 noOne[] ;
extern const u8 theyAre[];
extern const u8 tired_[];
extern const u8 reckless_[];
extern const u8 despondentAndIs[];
extern const u8 _More[];

extern const u8 whoIsLoyalTo[];

extern const u8 after_[];
extern const u8 theWarriorsReturn[];
extern const u8 isHere_[];
extern const u8 isDead_[];

extern const u8 theVictIs[];
extern const u8 theWatchWords[];
extern const u8 evilSharethWins[];
extern const u8 isOwnedBy[];

extern const u8 standsInTunnel[];

extern const u8 theIcemark[];

#endif

